﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XDGSkipLevelsCase
{
    public class ViewModel
    {
        public ObservableCollection<Captain> Data { get; }
        public ViewModel()
        {
            Crew tos, tng;

            tos = new Crew("TOS");
            tos.CrewMembers.Add(new Person("Spock"));
            tos.CrewMembers.Add(new Person("Leonard", "McCoy"));
            tos.CrewMembers.Add(new Person("Montgomery", "Scott"));
            tos.CrewMembers.Add(new Person("Nyota", "Uhura"));
            tos.CrewMembers.Add(new Person("Hikaru", "Sulu"));
            tos.CrewMembers.Add(new Person("Pavel", "Chekov"));

            tng = new Crew("TNG");
            tng.CrewMembers.Add(new Person("William", "Riker"));
            tng.CrewMembers.Add(new Person("Deanna", "Troi"));
            tng.CrewMembers.Add(new Person("Geordi", "LaForge"));
            tng.CrewMembers.Add(new Person("Worf"));

            Data = new ObservableCollection<Captain>();
            Data.Add(new Captain("James", "Kirk", tos));
            Data.Add(new Captain("Jean-Luc", "Picard", tng));
        }
    }

    public class Crew
    {
        public String CrewName { get; }
        public ObservableCollection<Person> CrewMembers { get; }
        public Crew(String crewName)
        {
            CrewName = crewName;
            CrewMembers = new ObservableCollection<Person>();
        }        
    }

    public class Person
    {
        public Name PersonName { get; }
        public Person(String firstName, String lastName)
        {
            PersonName = new Name(firstName, lastName);
        }
        public Person(String singleName)
        {
            PersonName = new Name(singleName);
        }
    }

    public class Captain
    {
        public Name CaptainName { get; }
        public Crew CaptainTeam { get; }
        public Captain(String firstName, String lastName, Crew crew)
        {
            CaptainName = new Name(firstName, lastName);
            CaptainTeam = crew;
        }
    }

    public class Name
    {
        public String First { get; }
        public String Last { get; }
        public String Full { get; }
        public String Short { get; }
        public String Formal { get; }
        public Name(String firstName, String lastName)
        {
            First = firstName;
            Last = lastName;
            Full = firstName + " " + lastName;
            Short = firstName[0] + ". " + lastName;
            Formal = lastName + ", " + firstName;
        }
        public Name(String singleName)
        {
            First = singleName;
            Last = singleName;
            Full = singleName;
            Short = singleName;
            Formal = singleName;
        }
    }
}
